Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/EfficientGlobalOptimizationAlgorithm.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/EfficientGlobalOptimizationAlgorithm.cs	(revision 15063)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/EfficientGlobalOptimizationAlgorithm.cs	(revision 15064)
@@ -24,5 +24,4 @@
 using System.Linq;
 using System.Threading;
-using System.Windows.Forms;
 using HeuristicLab.Algorithms.DataAnalysis;
 using HeuristicLab.Analysis;
@@ -35,6 +34,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Problems.DataAnalysis;
-using HeuristicLab.Problems.Instances.DataAnalysis;
-using HeuristicLab.Problems.Instances.DataAnalysis.Views;
+using HeuristicLab.Problems.Instances;
 using HeuristicLab.Random;
 
@@ -42,5 +40,5 @@
   [StorableClass]
   [Creatable(CreatableAttribute.Categories.Algorithms, Priority = 95)]
-  [Item("EfficientGlobalOptimizationAlgortihm", "Solves a problem by sequentially learning a model, solving a subproblem on the model and evaluating the best found solution for this subproblem.")]
+  [Item("EfficientGlobalOptimizationAlgorithm", "Solves a problem by sequentially learning a model, solving a subproblem on the model and evaluating the best found solution for this subproblem.")]
   public class EfficientGlobalOptimizationAlgorithm : BasicAlgorithm, ISurrogateAlgorithm<RealVector> {
     #region Basic-Alg-Essentials
@@ -84,9 +82,4 @@
     #endregion
 
-    #region TransmissionResultNames
-    public const string BestInfillSolutionResultName = "BestInfillSolution";
-    public const string BestInfillQualityResultName = "BestInfillQuality";
-    #endregion
-
     #region ParameterProperties
     public IFixedValueParameter<IntValue> GenerationSizeParemeter => Parameters[GenerationSizeParameterName] as IFixedValueParameter<IntValue>;
@@ -108,5 +101,4 @@
 
     #region Properties
-
     public int GenerationSize => GenerationSizeParemeter.Value.Value;
     public IInfillCriterion InfillCriterion => InfillCriterionParameter.Value;
@@ -123,5 +115,4 @@
       ? Samples.Skip(Samples.Count - MaximalDatasetSize)
       : Samples;
-
     private bool RemoveDuplicates => RemoveDuplicatesParameter.Value.Value;
     private RealVector BaselineVector => BaselineVectorParameter.Value;
@@ -161,9 +152,6 @@
     private DataTable ResultsQualities => (DataTable)Results[QualitiesChartResultName].Value;
     private DataRow ResultsQualitiesBest => ResultsQualities.Rows[BestQualitiesRowResultName];
-
     private DataRow ResultsQualitiesWorst => ResultsQualities.Rows[WorstQualitiesRowResultName];
-
     private DataRow ResultsQualitiesIteration => ResultsQualities.Rows[CurrentQualitiesRowResultName];
-
     private IRegressionSolution ResultsModel
     {
@@ -177,16 +165,20 @@
     protected EfficientGlobalOptimizationAlgorithm(bool deserializing) : base(deserializing) { }
     [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeseialization() {
+    protected void AfterDeseialization() {
       RegisterEventhandlers();
     }
-    protected EfficientGlobalOptimizationAlgorithm(EfficientGlobalOptimizationAlgorithm original, Cloner cloner)
-      : base(original, cloner) {
+    protected EfficientGlobalOptimizationAlgorithm(EfficientGlobalOptimizationAlgorithm original, Cloner cloner) : base(original, cloner) {
       Random = cloner.Clone(Random);
       if (original.Samples != null) Samples = original.Samples.Select(x => new Tuple<RealVector, double>(cloner.Clone(x.Item1), x.Item2)).ToList();
-      if (original.InitialSamples != null) Samples = original.InitialSamples.Select(x => new Tuple<RealVector, double>(cloner.Clone(x.Item1), x.Item2)).ToList();
+      if (original.InitialSamples != null) InitialSamples = original.InitialSamples.Select(x => new Tuple<RealVector, double>(cloner.Clone(x.Item1), x.Item2)).ToList();
       RegisterEventhandlers();
     }
     public override IDeepCloneable Clone(Cloner cloner) { return new EfficientGlobalOptimizationAlgorithm(this, cloner); }
     public EfficientGlobalOptimizationAlgorithm() {
+      IProblemInstanceExporter dummy = new RegressionProblem(); //this variable is irrelevant
+      //the dummy variable enforces a using-Statement for HeuristicLab.Problems.Instances
+      //"new ValueParameter<IDataAnalysisAlgorithm<IRegressionProblem>>" requires no using using-Statement, but nontheless it requires HeuristicLab.Problems.Instances to be referenced  
+      //Having HeuristicLab.Problems.Instances referenced but not used, causes the Essential-Unit-tests to fail. 
+
       var cmaes = new CMAEvolutionStrategy.CMAEvolutionStrategy {
         MaximumGenerations = 300,
@@ -206,26 +198,21 @@
       Parameters.Add(new FixedValueParameter<IntValue>(InfillOptimizationRestartsParameterName, "Number of restarts of the SubAlgortihm to avoid local optima", new IntValue(1)));
       Parameters.Add(new FixedValueParameter<IntValue>(GenerationSizeParameterName, "Number points that are sampled every iteration (stadard EGO: 1)", new IntValue(1)));
-      Parameters.Add(new ConstrainedValueParameter<IInfillCriterion>(InfillCriterionParameterName, "Decision what value should decide the next sample"));
-      InfillCriterionParameter.ValidValues.Add(new ExpectedImprovement());
-      InfillCriterionParameter.ValidValues.Add(new AugmentedExpectedImprovement());
-      InfillCriterionParameter.ValidValues.Add(new ExpectedQuality());
-      var eqi = new ExpectedQuantileImprovement();
-      InfillCriterionParameter.ValidValues.Add(eqi);
-      eqi.MaxEvaluationsParameter.Value = MaximumEvaluationsParameter.Value;
-      InfillCriterionParameter.ValidValues.Add(new MinimalQuantileCriterium());
-      InfillCriterionParameter.ValidValues.Add(new RobustImprovement());
-      InfillCriterionParameter.ValidValues.Add(new PluginExpectedImprovement());
       Parameters.Add(new FixedValueParameter<IntValue>(MaximalDataSetSizeParameterName, "The maximum number of sample points used to generate the model. Set 0 or less to use always all samples ", new IntValue(-1)));
       Parameters.Add(new FixedValueParameter<BoolValue>(RemoveDuplicatesParamterName, "Wether duplicate samples should be replaced by a single sample with an averaged quality. This GREATLY decreases the chance of ill conditioned models (unbuildable models) but is not theoretically sound as the model ignores the increasing certainty in this region"));
       Parameters.Add(new FixedValueParameter<FileValue>(InitialSamplesParameterName, "The file specifying some initial samples used to jump start the algorithm. These samples are not counted as evaluations. If InitialEvaluations is more than the samples specified in the file, the rest is uniformly random generated and evaluated.", new FileValue()));
       Parameters.Add(new ValueParameter<RealVector>(BaselineVectorParameterName, "A vector used to create a baseline, this vector is evaluated once and is not part of the modeling process (has no influence on algorithm performance)"));
-      var intialSamplingPlans = new ItemSet<IInitialSampling> { new UniformRandomSampling(), new LatinHyperCubeDesign() };
-      Parameters.Add(new ConstrainedValueParameter<IInitialSampling>(InitialSamplingPlanParamterName, intialSamplingPlans, intialSamplingPlans.First()));
-
+      var eqi = new ExpectedQuantileImprovement();
+      eqi.MaxEvaluationsParameter.Value = MaximumEvaluationsParameter.Value;
+      var criteria = new ItemSet<IInfillCriterion> { new ExpectedImprovement(), new AugmentedExpectedImprovement(), new ExpectedQuality(), eqi, new MinimalQuantileCriterium(), new PluginExpectedImprovement() };
+      Parameters.Add(new ConstrainedValueParameter<IInfillCriterion>(InfillCriterionParameterName, "Decision what value should decide the next sample", criteria, criteria.First()));
+      var intialSamplingPlans = new ItemSet<IInitialSampling> { new UniformRandomSampling(), new LatinHyperCubeDesignCreator() };
+      Parameters.Add(new ConstrainedValueParameter<IInitialSampling>(InitialSamplingPlanParamterName, "Determies the initial samples from which the first model can be built.", intialSamplingPlans, intialSamplingPlans.First()));
       SetInfillProblem();
       RegisterEventhandlers();
     }
     #endregion
-
+    public void SetInitialSamples(RealVector[] individuals, double[] qualities) {
+      InitialSamples = individuals.Zip(qualities, (individual, d) => new Tuple<RealVector, double>(individual, d)).ToList();
+    }
     protected override void Initialize(CancellationToken cancellationToken) {
       base.Initialize(cancellationToken);
@@ -235,6 +222,4 @@
       var infillProblem = InfillOptimizationAlgorithm.Problem as InfillProblem;
       if (infillProblem == null) throw new ArgumentException("InfillOptimizationAlgorithm has no InfillProblem. Troubles with Eventhandling?");
-      infillProblem.Problem = Problem;
-
 
       //random
@@ -259,5 +244,4 @@
 
     }
-
     protected override void Run(CancellationToken cancellationToken) {
       //initial samples
@@ -294,8 +278,4 @@
     }
 
-    public void SetInitialSamples(RealVector[] individuals, double[] qualities) {
-      InitialSamples = individuals.Zip(qualities, (individual, d) => new Tuple<RealVector, double>(individual, d)).ToList();
-    }
-
     #region Eventhandling
     private void RegisterEventhandlers() {
@@ -318,5 +298,4 @@
     private void OnInfillOptimizationAlgorithmChanged(object sender, EventArgs args) {
       SetInfillProblem();
-      InfillOptimizationAlgorithm.ProblemChanged -= InfillOptimizationProblemChanged;
       InfillOptimizationAlgorithm.ProblemChanged += InfillOptimizationProblemChanged;
     }
@@ -334,30 +313,5 @@
       RegressionAlgorithm.Problem = new RegressionProblem();
     }
-    private void OnInitialSamplesChanged(object sender, EventArgs args) {
-      IRegressionProblemData samplesData = null;
-      using (var importTypeDialog = new RegressionImportTypeDialog()) {
-        if (importTypeDialog.ShowDialog() != DialogResult.OK) return;
-        samplesData = new RegressionCSVInstanceProvider().ImportData(importTypeDialog.Path, importTypeDialog.ImportType, importTypeDialog.CSVFormat);
-        InitialSamplesParameter.ToStringChanged -= OnInitialSamplesChanged;
-        InitialSamplesParameter.Value.Value = importTypeDialog.Path;
-        InitialSamplesParameter.ToStringChanged -= OnInitialSamplesChanged;
-
-      }
-
-
-
-      var solutions = new RealVector[samplesData.Dataset.Rows];
-      var qualities = new double[samplesData.Dataset.Rows];
-      var inputVariables = samplesData.InputVariables.CheckedItems.ToArray();
-      for (var i = 0; i < solutions.Length; i++) {
-        qualities[i] = samplesData.Dataset.GetDoubleValue(samplesData.TargetVariable, i);
-        solutions[i] = new RealVector(inputVariables.Length);
-        for (var j = 0; j < inputVariables.Length; j++) solutions[i][j] = samplesData.Dataset.GetDoubleValue(inputVariables[j].Value.Value, i);
-      }
-
-      SetInitialSamples(solutions, qualities);
-
-    }
-
+    private void OnInitialSamplesChanged(object sender, EventArgs args) { }
     protected override void OnExecutionTimeChanged() {
       base.OnExecutionTimeChanged();
@@ -376,20 +330,7 @@
       base.Stop();
     }
-    protected override void OnProblemChanged() {
-      base.OnProblemChanged();
-      var infillProblem = InfillOptimizationAlgorithm.Problem as InfillProblem;
-      if (infillProblem == null) throw new ArgumentException("InfillOptimizationAlgorithm has no InfillProblem. Troubles with Eventhandling?");
-      infillProblem.Problem = Problem;
-    }
     #endregion
 
     #region helpers
-    private void SetInfillProblem() {
-      var infillProblem = new InfillProblem {
-        InfillCriterion = InfillCriterion,
-        Problem = Problem
-      };
-      InfillOptimizationAlgorithm.Problem = infillProblem;
-    }
     private IRegressionSolution BuildModel(CancellationToken cancellationToken) {
       var dataset = EgoUtilities.GetDataSet(DataSamples.ToList(), RemoveDuplicates);
@@ -406,5 +347,5 @@
       IRegressionSolution solution = null;
 
-      while (solution == null && i++ < 100) {  //TODO: Question: Why does GP degenerate to NaN so often? Answer: There is not even the slightest mitigation strategy for "almost duplicates" that ill-condition the covariance matrix.
+      while (solution == null && i++ < 100) {
         var results = EgoUtilities.SyncRunSubAlgorithm(RegressionAlgorithm, Random.Next(int.MaxValue));
         solution = results.Select(x => x.Value).OfType<IRegressionSolution>().SingleOrDefault();
@@ -451,12 +392,15 @@
       //parameterize and check InfillProblem
       var infillProblem = InfillOptimizationAlgorithm.Problem as InfillProblem;
-      if (infillProblem == null) throw new ArgumentException("InfillOptimizationAlgorithm does not have InfillProblem. Problem with Eventhandling?");
-      if (infillProblem.InfillCriterion != InfillCriterion) throw new ArgumentException("InfillCiriterion for Problem is not correct. Problem with Eventhandling?");
-      if (infillProblem.Problem != Problem) throw new ArgumentException("Expensive real problem is not correctly set in InfillProblem. Problem with Eventhandling?");
-      InfillCriterion.Initialize(ResultsModel, Problem.Maximization, infillProblem.Encoding);
+      if (infillProblem == null) throw new ArgumentException("InfillOptimizationAlgorithm does not have an InfillProblem.");
+      if (infillProblem.InfillCriterion != InfillCriterion) throw new ArgumentException("InfillCiriterion for Problem is not correctly set.");
+      var enc = Problem.Encoding as RealVectorEncoding;
+      infillProblem.Encoding.Bounds = enc.Bounds;
+      infillProblem.Encoding.Length = enc.Length;
+      infillProblem.Initialize(ResultsModel, Problem.Maximization);
+
+
 
       RealVector bestVector = null;
       var bestValue = infillProblem.Maximization ? double.NegativeInfinity : double.PositiveInfinity;
-
       for (var i = 0; i < InfillOptimizationRestarts; i++) {
         //optimize
@@ -464,10 +408,9 @@
         cancellationToken.ThrowIfCancellationRequested();
         //extract results
-        if (!res.ContainsKey(BestInfillSolutionResultName)) throw new ArgumentException("The InfillOptimizationAlgorithm did not return a best solution");
-        var v = res[BestInfillSolutionResultName].Value as RealVector;
-        if (!res.ContainsKey(BestInfillQualityResultName)) throw new ArgumentException("The InfillOptimizationAlgorithm did not return a best quality");
-        var d = res[BestInfillQualityResultName].Value as DoubleValue;
+        if (!res.ContainsKey(InfillProblem.BestInfillSolutionResultName)) throw new ArgumentException("The InfillOptimizationAlgorithm did not return a best solution");
+        var v = res[InfillProblem.BestInfillSolutionResultName].Value as RealVector;
+        if (!res.ContainsKey(InfillProblem.BestInfillQualityResultName)) throw new ArgumentException("The InfillOptimizationAlgorithm did not return a best quality");
+        var d = res[InfillProblem.BestInfillQualityResultName].Value as DoubleValue;
         if (d == null || v == null) throw new ArgumentException("The InfillOptimizationAlgorithm did not return the expected result types");
-
         //check for improvement
         if (infillProblem.Maximization != d.Value > bestValue) continue;
@@ -475,11 +418,8 @@
         bestVector = v;
       }
-
       InfillOptimizationAlgorithm.Runs.Clear();
       return bestVector;
     }
-    private Tuple<RealVector, double> Evaluate(RealVector point) {
-      return new Tuple<RealVector, double>(point, Problem.Evaluate(GetIndividual(point), Random));
-    }
+
     private void Analyze() {
       ResultsEvaluations = Samples.Count;
@@ -493,20 +433,36 @@
       ResultsQualitiesWorst.Values.Add(Samples[Problem.Maximization ? min : max].Item2);
       Problem.Analyze(Samples.Select(x => GetIndividual(x.Item1)).ToArray(), Samples.Select(x => x.Item2).ToArray(), Results, Random);
-
-      if (Samples.Count != 0 && Samples[0].Item1.Length == 2) {
-        var plotname = "DEBUG:Sample Distribution";
-        var rowInit = "Initial Samples";
-        var rowAll = "All Samples";
-        if (!Results.ContainsKey(plotname)) Results.Add(new Result(plotname, new ScatterPlot()));
-        var plot = Results[plotname].Value as ScatterPlot;
-        if (!plot.Rows.ContainsKey(rowInit) && InitialSamples != null && InitialSamples.Count > 0)
-          plot.Rows.Add(new ScatterPlotDataRow(rowInit, "samples from inital file (already evaulated)", InitialSamples.Select(x => new Point2D<double>(x.Item1[0], x.Item1[1]))));
-        if (!plot.Rows.ContainsKey(rowAll)) plot.Rows.Add(new ScatterPlotDataRow(rowAll, "All samples", new Point2D<double>[0]));
-        else { plot.Rows[rowAll].Points.Clear(); }
-        plot.Rows[rowAll].Points.AddRange(Samples.Select(x => new Point2D<double>(x.Item1[0], x.Item1[1])));
-
-
-      }
-    }
+      if (Samples.Count != 0 && Samples[0].Item1.Length == 2) AnalyzeSampleDistribution();
+      AnalyzePredictionCorrelation();
+    }
+
+    private void AnalyzeSampleDistribution() {
+      const string plotname = "DEBUG:Sample Distribution";
+      const string rowInit = "Initial Samples";
+      const string rowAll = "All Samples";
+      if (!Results.ContainsKey(plotname)) Results.Add(new Result(plotname, new ScatterPlot()));
+      var plot = (ScatterPlot)Results[plotname].Value;
+      if (!plot.Rows.ContainsKey(rowInit) && InitialSamples != null && InitialSamples.Count > 0)
+        plot.Rows.Add(new ScatterPlotDataRow(rowInit, "samples from inital file (already evaulated)", InitialSamples.Select(x => new Point2D<double>(x.Item1[0], x.Item1[1]))));
+      if (!plot.Rows.ContainsKey(rowAll)) plot.Rows.Add(new ScatterPlotDataRow(rowAll, "All samples", new Point2D<double>[0]));
+      else { plot.Rows[rowAll].Points.Clear(); }
+      plot.Rows[rowAll].Points.AddRange(Samples.Select(x => new Point2D<double>(x.Item1[0], x.Item1[1])));
+    }
+
+    private void AnalyzePredictionCorrelation() {
+      const string plotName = "Prediction";
+      const string rowName = "Samples";
+      const string lastrowName = "Last Sample";
+      if (!Results.ContainsKey(plotName)) Results.Add(new Result(plotName, new ScatterPlot()));
+      var plot = (ScatterPlot)Results[plotName].Value;
+      if (!plot.Rows.ContainsKey(rowName)) plot.Rows.Add(new ScatterPlotDataRow(rowName, rowName, new List<Point2D<double>>()));
+      if (!plot.Rows.ContainsKey(lastrowName)) plot.Rows.Add(new ScatterPlotDataRow(lastrowName, lastrowName, new List<Point2D<double>>()));
+      var p = Samples[Samples.Count - 1];
+      if (ResultsModel != null) plot.Rows[rowName].Points.Add(new Point2D<double>(ResultsModel.Model.GetEstimation(p.Item1), p.Item2, p.Item1));
+      plot.VisualProperties.YAxisTitle = "True Objective Value";
+      plot.VisualProperties.XAxisTitle = "Predicted Objective Value";
+
+    }
+
     private Individual GetIndividual(RealVector r) {
       var scope = new Scope();
@@ -514,4 +470,11 @@
       return new SingleEncodingIndividual(Problem.Encoding, scope);
     }
+    private Tuple<RealVector, double> Evaluate(RealVector point) {
+      return new Tuple<RealVector, double>(point, Problem.Evaluate(GetIndividual(point), Random));
+    }
+
+    private void SetInfillProblem() {
+      InfillOptimizationAlgorithm.Problem = new InfillProblem { InfillCriterion = InfillCriterion };
+    }
     #endregion
   }
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/EgoUtilities.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/EgoUtilities.cs	(revision 15063)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/EgoUtilities.cs	(revision 15064)
@@ -25,4 +25,5 @@
 using System.Threading;
 using HeuristicLab.Common;
+using HeuristicLab.Core;
 using HeuristicLab.Data;
 using HeuristicLab.Encodings.RealVectorEncoding;
@@ -32,4 +33,5 @@
 namespace HeuristicLab.Algorithms.EGO {
   internal static class EgoUtilities {
+    //Extention methods for convenience
     public static int ArgMax<T>(this IEnumerable<T> values, Func<T, double> func) {
       var max = double.MinValue;
@@ -49,5 +51,17 @@
       return ArgMax(values, x => -func.Invoke(x));
     }
+    public static double GetEstimation(this IRegressionModel model, RealVector r) {
+      var dataset = GetDataSet(new[] { new Tuple<RealVector, double>(r, 0.0) }, false);
+      return model.GetEstimatedValues(dataset, new[] { 0 }).First();
+    }
+    public static double GetVariance(this IConfidenceRegressionModel model, RealVector r) {
+      var dataset = GetDataSet(new[] { new Tuple<RealVector, double>(r, 0.0) }, false);
+      return model.GetEstimatedVariances(dataset, new[] { 0 }).First();
+    }
+    public static double GetDoubleValue(this IDataset dataset, int i, int j) {
+      return dataset.GetDoubleValue("input" + j, i);
+    }
 
+    //Sub-ALgorithms
     public static ResultCollection SyncRunSubAlgorithm(IAlgorithm alg, int random) {
 
@@ -64,9 +78,15 @@
       EventWaitHandle trigger = new AutoResetEvent(false);
       Exception ex = null;
-      EventHandler<EventArgs<Exception>> exhandler = (sender, e) => ex = e.Value;
+      EventHandler<EventArgs<Exception>> exhandler = (sender, e) => { ex = e.Value; trigger.Set(); };
       EventHandler stoppedHandler = (sender, e) => trigger.Set();
+
+      alg.ExceptionOccurred -= exhandler; //avoid double attaching in case of pause
       alg.ExceptionOccurred += exhandler;
+      alg.Stopped -= stoppedHandler;
       alg.Stopped += stoppedHandler;
-      alg.Prepare();
+      alg.Paused -= stoppedHandler;
+      alg.Paused += stoppedHandler;
+
+      if (alg.ExecutionState != ExecutionState.Paused) alg.Prepare();
       alg.Start();
       trigger.WaitOne();
@@ -77,40 +97,20 @@
     }
 
-    public static double GetEstimation(this IRegressionModel model, RealVector r) {
-      var dataset = GetDataSet(new[] { new Tuple<RealVector, double>(r, 0.0) }, false);
-      return model.GetEstimatedValues(dataset, new[] { 0 }).First();
-    }
-    public static double GetVariance(this IConfidenceRegressionModel model, RealVector r) {
-      var dataset = GetDataSet(new[] { new Tuple<RealVector, double>(r, 0.0) }, false);
-      return model.GetEstimatedVariances(dataset, new[] { 0 }).First();
-    }
-
-
-    public static double GetDoubleValue(this IDataset dataset, int i, int j) {
-      return dataset.GetDoubleValue("input" + j, i);
-    }
+    //RegressionModel extensions
+    public const double DuplicateResolution = 0.0001;
     public static Dataset GetDataSet(IReadOnlyList<Tuple<RealVector, double>> samples, bool removeDuplicates) {
-      if (removeDuplicates)
-        samples = RemoveDuplicates(samples); //TODO duplicates require heteroskedasticity in Models
-
-
+      if (removeDuplicates) samples = RemoveDuplicates(samples); //TODO duplicate removal leads to incorrect uncertainty values in models
       var dimensions = samples[0].Item1.Length + 1;
       var data = new double[samples.Count, dimensions];
       var names = new string[dimensions - 1];
       for (var i = 0; i < names.Length; i++) names[i] = "input" + i;
-
       for (var j = 0; j < samples.Count; j++) {
         for (var i = 0; i < names.Length; i++) data[j, i] = samples[j].Item1[i];
         data[j, dimensions - 1] = samples[j].Item2;
-
       }
-
-
       return new Dataset(names.Concat(new[] { "output" }).ToArray(), data);
     }
-
     private static IReadOnlyList<Tuple<RealVector, double>> RemoveDuplicates(IReadOnlyList<Tuple<RealVector, double>> samples) {
       var res = new List<Tuple<RealVector, double, int>>();
-
       foreach (var sample in samples) {
         if (res.Count == 0) {
@@ -118,8 +118,7 @@
           continue;
         }
-
         var index = res.ArgMin(x => Euclidian(sample.Item1, x.Item1));
         var d = Euclidian(res[index].Item1, sample.Item1);
-        if (d > 0.0001)
+        if (d > DuplicateResolution)
           res.Add(new Tuple<RealVector, double, int>(sample.Item1, sample.Item2, 1));
         else {
@@ -131,25 +130,7 @@
       return res.Select(x => new Tuple<RealVector, double>(x.Item1, x.Item2 / x.Item3)).ToArray();
     }
-
     private static double Euclidian(IEnumerable<double> a, IEnumerable<double> b) {
       return Math.Sqrt(a.Zip(b, (d, d1) => d - d1).Sum(d => d * d));
     }
-
-    public static DoubleMatrix GetBoundingBox(IEnumerable<RealVector> vectors) {
-      DoubleMatrix res = null;
-      foreach (var vector in vectors)
-        if (res == null) {
-          res = new DoubleMatrix(vector.Length, 2);
-          for (var i = 0; i < vector.Length; i++)
-            res[i, 0] = res[i, 1] = vector[i];
-        } else
-          for (var i = 0; i < vector.Length; i++) {
-            res[i, 0] = Math.Min(vector[i], res[i, 0]);
-            res[i, 1] = Math.Max(vector[i], res[i, 1]);
-          }
-      return res;
-    }
-
-
   }
 }
